質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.07%

例外処理内容の取得方法について

受付中

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 181

Kokku

score 15

https://datumstudio.jp/blog/azure-computer-vision-api%E3%81%A8face-api%E3%82%92python%E3%81%8B%E3%82%89%E5%88%A9%E7%94%A8%E3%81%99%E3%82%8B

このページにある下記コードを実行するとこんなエラーが出てしまいます。

########### Python 3.2 #############
import http.client, urllib.request, urllib.parse, urllib.error, base64
import json

#### Request headers
#'Content-Type': APIに送るメディアのタイプ. 
#  'application/json'(URL指定の場合), 'application/octet-stream' (Local ファイル転送の場合)
#'Ocp-Apim-Subscription-Key': APIキーを指定する
headers = {
#    'Content-Type': 'application/json',
    'Content-Type': 'application/octet-stream',
    'Ocp-Apim-Subscription-Key': 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX',
}

#### Request parameters
# 取得したい情報について、パラメータを指定する
# 'returnFaceId': 入力した顔画像に付与されるIDを返すかどうか
# 'returnFaceLandmarks' : 目や口などの特徴となる部分の座標を返すかどうか
# 'returnFaceAttributes' : 認識した顔からわかる属性を返す
#   指定できるパラメータは以下で、コンマで分けて複数指定可能
#       age, gender, headPose, smile, facialHair, 
#       glasses, emotion, hair, makeup, occlusion, 
#       accessories, blur, exposure and noise
params = urllib.parse.urlencode({
    'returnFaceId': 'true',
#    'returnFaceLandmarks': 'true',
    'returnFaceAttributes': 'age,gender,smile,facialHair,emotion'
})

#### Request body
# 入力したい画像の指定をする. 画像URLの指定, local ファイルの指定から選択
# 画像はJPEG, PNG, GIF, BMPに対応
# サイズの上限は4MB
# 認識可能な顔のサイズは 36x36 - 4096x4096 pixelsの範囲
# 最大64個の顔を認識可能

## URL 指定の場合以下のコメントアウトを外すし、image_urlを指定する
#image_url = 'https://XXXXX'
#body = { 'url': image_url }
#body = json.dumps(body)

## Local file指定の場合
# 以下の image_file_path に読み込むファイルのパスを指定する
image_file_path = 'c:/temp/Lenna.jpg'
image_file = open(image_file_path,'rb')
body = image_file.read()
image_file.close()

#### API request
# 接続先リージョンによっては, 以下HTTPSConnection の "westus.api.cognitive.microsoft.com" 部分は変更する.
# この場合は「westus」なので北米西部リージョン
# なお "/face/v1.0/detect?%s" の部分が接続先APIの機能を指定している
try:
    conn = http.client.HTTPSConnection('https://shotaaa.cognitiveservices.azure.com/')
    conn.request("POST", "/face/v1.0/detect?%s" % params, body, headers)
    response = conn.getresponse()
    data = json.loads(response.read())
    print(json.dumps(data, indent=4))
    conn.close()
except Exception as e:
    print("[Errno {0}] {1}".format(e.errno, e.strerror))

####################################
---------------------------------------------------------------------------
ValueError                                Traceback (most recent call last)
~\Anaconda3\lib\http\client.py in _get_hostport(self, host, port)
    886                 try:
--> 887                     port = int(host[i+1:])
    888                 except ValueError:

ValueError: invalid literal for int() with base 10: '//shotaaa.cognitiveservices.azure.com/'

During handling of the above exception, another exception occurred:

InvalidURL                                Traceback (most recent call last)
<ipython-input-2-f0904f9e9afa> in <module>
     53 try:
---> 54     conn = http.client.HTTPSConnection('https://shotaaa.cognitiveservices.azure.com/')
     55     conn.request("POST", "/face/v1.0/detect?%s" % params, body, headers)

~\Anaconda3\lib\http\client.py in __init__(self, host, port, key_file, cert_file, timeout, source_address, context, check_hostname, blocksize)
   1380                                                   source_address,
-> 1381                                                   blocksize=blocksize)
   1382             if (key_file is not None or cert_file is not None or

~\Anaconda3\lib\http\client.py in __init__(self, host, port, timeout, source_address, blocksize)
    850 
--> 851         (self.host, self.port) = self._get_hostport(host, port)
    852 

~\Anaconda3\lib\http\client.py in _get_hostport(self, host, port)
    891                     else:
--> 892                         raise InvalidURL("nonnumeric port: '%s'" % host[i+1:])
    893                 host = host[:i]

InvalidURL: nonnumeric port: '//shotaaa.cognitiveservices.azure.com/'

During handling of the above exception, another exception occurred:

AttributeError                            Traceback (most recent call last)
<ipython-input-2-f0904f9e9afa> in <module>
     59     conn.close()
     60 except Exception as e:
---> 61     print("[Errno {0}] {1}".format(e.errno, e.strerror))
     62 
     63 ####################################

AttributeError: 'InvalidURL' object has no attribute 'errno'

どこから直せばいいのかわからず、一番最後のエラーも探しても見つかりませんでした。
教えてもらえますでしょうか。

e.Errnoはどう書き換えたら正常に動くようになるのでしょうか。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • Orlofsky

    2020/06/24 16:00

    URLは https://teratail.com/help/question-tips#questionTips3-7 の [リンク] で [リンク先のタイトル](http...)

    キャンセル

  • quiqui

    2020/06/24 16:08

    貼ったコード間違ってませんか? 実行したコードじゃないのでは?

    キャンセル

  • Kokku

    2020/06/24 16:13

    修正しました

    キャンセル

  • meg_

    2020/06/24 20:36

    とりあえず「print("[Errno {0}] {1}".format(e.errno, e.strerror))」を「print(e)」にしてみてはどうでしょうか?
    ちなみにお使いのOSは何でしょうか?(質問に追記してください)

    キャンセル

回答 1

0

リンク先の例は、その参照先も含め色々間違っているようです。

InvalidURL

http.client.HTTPSConnection() の引数は URL ではなくホスト名にするのが正しいようです:

    conn = http.client.HTTPSConnection('shotaaa.cognitiveservices.azure.com')

参考:
Answer: Python HTTP Client GET issue with port 
python - 使用http.client.https.connnection向Microsoft Azure服务发出连接请求以分析图像 - 堆栈内存溢出

e.errno

e.Errnoはどう書き換えたら正常に動くようになるのでしょうか。

ひとまず、次のように直すとデバッグしやすいでしょう:

print(e)

errno プロパティは OSError のサブクラスだけが持っているプロパティのようです。
次のページをブラウザの検索で「OSError」で検索してみましょう。
組み込み例外 — Python 3.8.3 ドキュメント

InvalidURL は OSError を継承していません。
InvalidURL の実装
HTTPException の実装

参考: Answer: 'exceptions.RuntimeError' - Object has no attribute 'errno' [closed] 

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.07%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

関連した質問

同じタグがついた質問を見る